import es
import gamethread, random

import psyco
psyco.full()
               
drug_users = {}

class Drug:
    def __init__(self, userid):
        self.repeat = 0
        self.delay = 0
        self.userid = int(userid)
        self.sound = "sas/sas_drug.wav"
        self.Function = None
       
    def Start(self, delay=1, repeat = "INDEFINITELY"):
        self.delay = delay
        self.repeat = repeat
        gamethread.delayedname(delay, '%d_drug' % self.userid, self.Loop)
   
    def Stop(self, delete = False):
        self.repeat = 0
        self.delay = 0
        gamethread.cancelDelayed('%d_drug' % self.userid)
        Delete(self.userid)
       
    def Loop(self):
        if not self.repeat == "INDEFINITELY" and self.repeat > 0:
            self.repeat -= 1
        elif not self.repeat == "INDEFINITELY":
            self.Stop(True)
            return
        if not es.getplayerprop(self.userid, 'CBasePlayer.pl.deadflag'):
            drug_axe_x = random.randint(1,30)
            drug_axe_y = random.randint(1,30)
            drug_angle = random.randint(1,30)
            drug_axe_x_reverse = random.randint(0,1)
            drug_axe_y_reverse = random.randint(0,1)
            drug_angle_reverse = random.randint(0,1)

            if int(drug_axe_x_reverse) == 1:
                drug_axe_x = int(drug_axe_x_reverse) - int(drug_axe_x)
            if int(drug_axe_y_reverse) == 1:
                drug_axe_y = int(drug_axe_y_reverse) - int(drug_axe_y)
            if int(drug_angle_reverse) == 1:
                drug_angle = int(drug_angle_reverse) - int(drug_angle)

            es.setplayerprop(self.userid, "CCSPlayer.baseclass.localdata.m_Local.m_vecPunchAngle", "%d,%d,%d" % (int(drug_axe_x),int(drug_axe_y),int(drug_angle)))
                
                
            if self.sound:
                es.emitsound('player', self.userid, self.sound, 1.0, 0.7)
            gamethread.delayedname(self.delay, '%d_drug' % self.userid, self.Loop)
        else:
            self.Stop(True)
           
    def Delete(self):
        self.Stop(True)

def EasyDrug(userid):
    userid = int(userid)
    if not drug_users.has_key(userid):
        drug_users[userid] = Drug(userid)
        drug_users[userid].Type = "Easy"
    return drug_users[userid]
   
def Delete(userid):
    userid = int(userid)
    if not drug_users.has_key(userid):
        es.dbgmsg(0, 'ERROR: Cannot find instance %s inside drug'%userid)
    else:
        gamethread.cancelDelayed('%d_drug' % userid)
        del drug_users[userid]

selfmodule = __import__('druglib')

def player_disconnect(ev):
    userid = ev['userid']
    if drug_users.has_key(userid):
        gamethread.cancelDelayed('%d_drug' % userid)
        Delete(userid)
es.addons.registerForEvent(selfmodule, 'player_disconnect', player_disconnect)
       
def player_death(ev):
    userid = ev['userid']
    if drug_users.has_key(userid):
        gamethread.cancelDelayed('%d_drug' % userid)
        Delete(userid)
es.addons.registerForEvent(selfmodule, 'player_death', player_death)
       
def round_end(ev):
    for userid in es.getUseridList():
        if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
            userid = int(userid)
            if drug_users.has_key(userid):
                Delete(userid)
es.addons.registerForEvent(selfmodule, 'round_end', round_end)

def server_cvar(event_var):
    if event_var['cvarname'] == 'mp_restartgame' and int(event_var['cvarvalue']) == 1:
        for userid in drug_users.keys():
            gamethread.cancelDelayed('%d_drug' % userid)
            Delete(userid)
es.addons.registerForEvent(selfmodule, 'server_cvar', server_cvar)

def round_start(event_var):
    for userid in drug_users.keys():
        gamethread.cancelDelayed('%d_drug' % userid)
        Delete(userid)
es.addons.registerForEvent(selfmodule, 'round_start', round_start)

